#!/usr/bin/env perl

# $Id: insertjamofiller.pl,v 1.4 2011/08/03 09:52:15 nomos Exp $
#
# written by Dohyun Kim <nomos at ktug dot kr>
# 2011-06-23
# public domain

binmode STDIN,":utf8";
binmode STDOUT,":utf8";

my $cho  = "\x{1100}-\x{115F}\x{A960}-\x{A97C}";
my $jung = "\x{1160}-\x{11A7}\x{D7B0}-\x{D7C6}";
my $jong = "\x{11A8}-\x{11FF}\x{D7CB}-\x{D7FB}";

while(<>) {
  s/([$cho])([$jong])/$1\x{1160}\x{115F}\x{1160}$2/g;
  s/(^|[^$jung$jong])([$jong])/$1\x{115F}\x{1160}$2/g;
  s/(^|[^$cho$jung])([$jung])/$1\x{115F}$2/g;
  s/([$cho])([^$cho$jung]|$)/$1\x{1160}$2/g;
  print;
}
